//----------------------------------------------------------------------//
// EyeTra																//
//----------------------------------------------------------------------//
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <System.Classes.hpp>
#include <System.Actions.hpp>
#include <Vcl.Controls.hpp>
#include <Vcl.StdCtrls.hpp>
#include <Vcl.Forms.hpp>
#include <Vcl.ComCtrls.hpp>
#include <Vcl.ExtCtrls.hpp>
#include <Vcl.Buttons.hpp>
#include <Vcl.Dialogs.hpp>
#include <Vcl.Mask.hpp>
#include <Vcl.ActnList.hpp>
#include <Vcl.Menus.hpp>
#include <Vcl.StdActns.hpp>
#include <Vcl.ExtDlgs.hpp>
#include <Vcl.ToolWin.hpp>
#include "UIniFile.h"

//---------------------------------------------------------------------------
#define SUPPORT_URL _T("http://nekomimi.la.coocan.jp/")

//---------------------------------------------------------------------------
#define WM_FORM_SHOWED		(WM_APP + 1)

#define IMG_FPS	24

//---------------------------------------------------------------------------
class TParaTraForm : public TForm
{
__published:	// IDE ŊǗR|[lg
	TAction *StartAction;
	TActionList *ActionList1;
	TButton *StartBtn;
	TCheckBox *CheckBox_G;
	TCheckBox *CheckBox_RT;
	TCheckBox *CheckBox_SC;
	TColorDialog *ColorDialog1;
	TComboBox *ImgComboBox;
	TComboBox *MoveComboBox;
	TFileExit *FileExit1;
	TFontDialog *FontDialog1;
	TGroupBox *CharGroupBox;
	TGroupBox *GridGroupBox;
	TGroupBox *MoveGroupBox;
	TGroupBox *TimeGroupBox;
	TGroupBox *W_T_GroupBox;
	THelpContents *HelpContents1;
	TLabel *Label1;
	TLabel *Label2;
	TLabeledEdit *CharEdit;
	TLabeledEdit *ImageSizeEdit;
	TLabeledEdit *TimeEdit;
	TMainMenu *MainMenu1;
	TMenuItem *AboutItem;
	TMenuItem *C1;
	TMenuItem *C2;
	TMenuItem *ExitItem;
	TMenuItem *File1;
	TMenuItem *Help1;
	TMenuItem *WebItem;
	TOpenPictureDialog *OpenPictureDialog1;
	TPanel *ExePanel;
	TPanel *OptPanel;
	TPanel *PausePanel;
	TPopupMenu *PresetMenu;
	TRadioGroup *SpeedGroup;
	TSpeedButton *ColBgBtn;
	TSpeedButton *ColCharBtn;
	TSpeedButton *ColGridBtn;
	TSpeedButton *FontBtn;
	TSpeedButton *ImageBtn;
	TTimer *Timer1;
	TTimer *Timer2;
	TToolBar *PresetBar;
	TToolButton *ToolButton1;
	TToolButton *ToolButton2;
	TToolButton *ToolButton3;
	TToolButton *ToolButton4;
	TToolButton *ToolButton5;
	TToolButton *ToolButton6;
	TToolButton *ToolButton7;
	TToolButton *ToolButton8;
	TTrackBar *TrackBar_GW;
	TTrackBar *TrackBar_S0;
	TTrackBar *TrackBar_S1;

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall TrackBar_S0Change(TObject *Sender);
	void __fastcall TrackBar_S1Change(TObject *Sender);
	void __fastcall ImageSizeEditChange(TObject *Sender);
	void __fastcall ColorBtnClick(TObject *Sender);
	void __fastcall FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
	void __fastcall FormPaint(TObject *Sender);
	void __fastcall TrackBar_GWChange(TObject *Sender);
	void __fastcall ImgOptChanged(TObject *Sender);
	void __fastcall FontBtnClick(TObject *Sender);
	void __fastcall Timer2Timer(TObject *Sender);
	void __fastcall ImgObjChange(TObject *Sender);
	void __fastcall TrackBar_S0Enter(TObject *Sender);
	void __fastcall TrackBar_S1Enter(TObject *Sender);
	void __fastcall StartActionExecute(TObject *Sender);
	void __fastcall StartActionUpdate(TObject *Sender);
	void __fastcall AboutItemClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall ImageBtnClick(TObject *Sender);
	void __fastcall WebItemClick(TObject *Sender);
	void __fastcall PresetBtnClick(TObject *Sender);
	void __fastcall C2Click(TObject *Sender);
	void __fastcall FormDblClick(TObject *Sender);
	void __fastcall PausePanelClick(TObject *Sender);

private:	// [U[錾
	UsrIniFile *IniFile;

	int PresetNo;

	TStringList *MotionList;
	int  StartIndex;
	bool Pause;

	TFont *CharFont;
	TColor col_fg, col_bg, col_grid;

	Graphics::TBitmap *ObjBuff;
	UnicodeString ImageFile;

	int  maxImgSize;
	int  minInterSize;
	int  maxInterSize;
	int  ptrMotion;
	int  maxMovWidth;

	int  X,Y,S,A;
	int  vDef, vX,vY;
	int  vS,vA;
	bool Scaling;
	bool IsChar;

	bool Initialized;
	bool InhRepaint;
	TWindowState OrgWinState;

	void __fastcall WmFormShowed(TMessage &msg);

	void __fastcall LoadOption(int n);
	void __fastcall SaveOption(int n);

	void __fastcall SetObjImg();
	void __fastcall SetObjPos(int x, int y, int s, int a);
	void __fastcall MoveObject(WideChar prm, int step = 0);
	void __fastcall MoveObject(UnicodeString prm);
	void __fastcall RandomObject(int step);
	void __fastcall OrbitalObject(bool x_sw, bool y_sw, bool s_sw, bool m_sw, bool rev,  int n = 1);
	void __fastcall Stop();

public:		// [U[錾
	__fastcall TParaTraForm(TComponent* Owner);

	BEGIN_MESSAGE_MAP
		VCL_MESSAGE_HANDLER(WM_FORM_SHOWED,		TMessage,	WmFormShowed)
	END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TParaTraForm *ParaTraForm;
//---------------------------------------------------------------------------
#endif
